program acrodde ;

{ This program uses DDE to ask the Acrobat viewer (reader or exchange)	}
{ to close down. It produces no diagnostics for failure.		}
{ Written by Aandi Inston.						}
{ May be freely redistributed, if the above credit is not removed	}

uses
  ddeml ,
  winprocs , wintypes , strings ;


function DDeCallBack ( CallType : word ;
		Fmt : word ;
		Conv : HConv ; hsz1, hsz2: HSZ;
		Data: HDDEData; Data1, Data2: Longint
		) : HDDEData ;
  export ;
  begin
    DDeCallBack := 0
  end { DDECallBack } ;


function SendViewerCommand
	( InstallationID : longint ;
	  Command : PChar ) : boolean ;
  var
    Service , Topic : HSz ;
    ConversationHandle : HConv ;
    Data : HDDEData ;
    Result : longint ;
    IsOk : boolean ;
  begin
    IsOk := false ;

    { Create string handle to service/topic	}
    Service := DdeCreateStringHandle(InstallationId, 'acroview', CP_WINANSI);
    Topic := DdeCreateStringHandle(InstallationId, 'control', CP_WINANSI);

    { Attempt to start conversation 		}
    ConversationHandle := DdeConnect ( InstallationId, Service , Topic, nil ) ;

    if ConversationHandle <> 0
    then
      begin
	{ Send command to server		}
	Data := DdeClientTransaction ( Command, 		{ data to pass }
				      strlen(Command)+1 ,       { length of data }
				      ConversationHandle,       { handle of conversation }
				      0,              		{ handle of name-string }
				      CF_TEXT,           	{ clipboard format }
				      XTYP_EXECUTE,     	{ transaction type }
				      1000, 			{ timeout duration }
				      @Result ) ;
	if Data <> 0 then IsOk := true ;

	{ Disconnect				}
	if not DDeDisconnect ( ConversationHandle )
	then IsOk := false ;
      end ;

    DdeFreeStringHandle ( InstallationId , Service ) ;
    DdeFreeStringHandle ( InstallationId , Topic ) ;

    SendViewerCommand := IsOk
  end { SendViewerCommand } ;



function SingleViewerDDECommand ( HInstance : THandle ; Command : PChar ) : boolean ;
  var
    InstanceId : longint ;
    ProcInstance : TFarProc ;
    InitResult : word ;
    IsOk : boolean ;
  begin
     IsOk := false ;

     ProcInstance := MakeProcInstance ( @DDECallBack , HInstance ) ;
     if ProcInstance <> nil then
       begin
	 InstanceID := 0 ;

	 InitResult := DdeInitialize(InstanceID, TCallBack(ProcInstance),
		      AppCmd_ClientOnly, 0 ) ;
	 if InitResult = DMlErr_No_Error
	 then
	   begin
	     IsOk := SendViewerCommand ( InstanceID , Command ) ;

	     if not DDEUninitialize(InstanceID)
	     then IsOk := false ;
	   end ;

	 FreeProcInstance ( ProcInstance ) ;
       end ;

     SingleViewerDDECommand := IsOk
  end { SingleViewerDDECommand } ;

begin
  { This command closes the viewer }
  SingleViewerDDECommand ( HInstance , '[AppExit]') ;

  { This command would open a file. The viewer must already be running 	}
  { so it will never work if the AppExit command is left in above.	}
  { Don't forget that installation locations may differ.		}
  { if not SingleViewerDDECommand ( HInstance , '[FileOpen(c:\acroread\help\help_r.pdf)]' )
  then MessageBox ( 0 , 'DDE request failed' , 'DDE!', mb_ok or mb_iconexclamation ) ; {}
end .